<template>
  <div class="tag-input-container" >
    <base-text-input :on-text-change="onChangeText" @open-option-list="state.showOptionList = true"  @close-option-list="state.showOptionList = false"></base-text-input>
    <div class="tag-info-container">

      <div class="input-options" v-if="state.showOptionList">
        <list @on-select="tagInputSelectedTags = [...selectedTags, $event]" :data-source="dataSource.filter(x => !!!state.searchText? x : x.name.toLowerCase().match(state.searchText.toLowerCase()))" :render-row-component="renderRowComponent"></list>
      </div>

      <div class="tags-list">
        <chips v-for="(cur, index) in selectedTags" :key="index">{{ renderRowComponent(cur) }}</chips>
      </div>

    </div>
  </div>
</template>

<script>
import BaseTextInput from "@/components/core/BaseTextInput";
import Chips from "@/components/core/Chips";
import List from "@/components/core/List";
import {computed, reactive} from "vue";

export default {
  name: "TagInput",
  props: {
    dataSource: {
      type: Array,
      required: true
    },
    renderRowComponent: {
      type: Function,
      default: inp => inp
    },
    onSelectedTagsChanged: {
      type: Function,
      default: inp => inp
    },
    selectedTags: {
      type: Array,
      default: []
    }
  },
  components: {List, Chips, BaseTextInput},
  setup(props, {emit}) {
    const tagInputSelectedTags = computed({
      get: () => props.selectedTags,
      set: (val) => emit('update:selectedTags', val)
    })

    const onChangeText = searchText => state.searchText = searchText

    const state = reactive({
      filteredDataSource : props.dataSource,
      showOptionList: false,
      searchText: ''
    })
    const r = t => {
      console.log(t)
    }
    return {
      state,
      onChangeText,
      tagInputSelectedTags,
      r
    }
  }
}
</script>

<style scoped lang="scss">
@import "../../styles/colors";
@import "../../styles/sizes";

.tag-input-container {
  display: flex;
  flex-direction: column;
  gap: 8px;

  .tag-info-container {
    position: relative;

    .input-options {
      position: absolute;
      width: 100%;
      z-index: 2;
    }

    .tags-list {
      position: absolute;
      display: flex;
      flex-wrap: wrap;
      gap: 8px;
      flex-direction: row;
    }
  }
}
</style>